﻿--[[
	Author: Darcey@AllForTheCode.co.uk
--]]

-- Var ini
local t = 0;
local tLim = 0;
local tDelay = 1000;
local strange = 0;
local playerCoordinates;
local px = 0;
local py = 0;
local zone = "";
local subZone = "";
local zoneText = "";
local inInstance = false;
local instanceType = "";


-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
DCoordsUpdateHandler = function()
	--toChat( GetMouseFocus():GetName() );
	--print( GetMouseFocus():GetName() );

	-- DCoords ready?
	if ( DCVGlobal["DCReady"] == false ) then
		return;
	end
	
	
	-- instance flags
	inInstance, instanceType = IsInInstance();
	
	
	
	-- Combat flag
	DCVGlobal["IsInCombat"] = UnitAffectingCombat('player');
	if (not DCVGlobal["IsInCombat"]) then
		DCVGlobal["IsInCombat"] = false;
	end
	
	
	-- Handle update timing
	t = t+1;
	
	if (t <= tLim) then
		return;
	else
		t = 0;
		
		if (inInstance == true) then
			tDelay = DCoordsVDB["updateDelayInDungeonOrRaid"];
		else
	
			if (DCVGlobal["IsInCombat"] == false) then
				tDelay = DCoordsVDB["updateDelay"];
			else
				tDelay = DCoordsVDB["updateDelayInCombat"];
			end
			
		end
	end
	
	tLim = t + tDelay;
	
	--toChat("DC: tDelay = " .. tostring(tDelay) .. "   tlim = " .. tostring(tLim) );
	
	
	-- Get the players coordinates
	
	
	
	-- Minimap text
	if (MinimapZoneText:IsVisible() == true) then
		local miniMapCoordinates = getPlayerCoordinates(DCoordsVDB["Minimap"].decimalPrecision);
		MinimapZoneText:SetText( miniMapCoordinates );
	end
	
	
	-- Update MainBar
	if ( DCoordsVDB["MainBar"].visible == true ) then
		updateMainBar();
	end
	
	-- Update WorldMap
	--if ( DCoordsVDB["WorldMap"].visible == true and WorldMapFrame:IsVisible() == true ) then
	if ( WorldMapFrame:IsVisible() == true ) then
	
		if ( DCVGlobal["IsInCombat"] == false ) then
			updateWorldMap();
		end
		
	end
	
	
	
	
end
-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #









-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
function getPlayerCoordinates(decimalPrecision)
	px, py = GetPlayerMapPosition("player");
	
	if (px == nil) then
		px = 0;
	end
	
	if (py == nil) then
		py = 0;
	end
	
	local precision = "%.".. decimalPrecision .."f";
	px = string.format(precision, (px*100));
	py = string.format(precision, (py*100));
	
	return (px  .. " : " .. py);
end
-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #






-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
function updateMainBar()
		
	-- Prevent update if MainBar is not visible
	if ( DCVGlobal["DCMainBar"]:IsVisible() == false) then
		return;
	end

	if (DCoordsVDB["MainBar"].showZone == true) then
		zone = GetZoneText();
	else
		zone = "";
	end
	
	if (DCoordsVDB["MainBar"].showSubZone == true) then
		subZone = GetSubZoneText();
	else
		subZone = "";
	end
	
	
	
	playerCoordinats = getPlayerCoordinates(DCoordsVDB["MainBar"].decimalPrecision);
	
	
	
	if (tonumber(px) < 0.01 and tonumber(py) < 0.01) then
		if (zone ~= "") and (subZone ~= "") then
			location = zone .. " - " .. subZone;
		elseif (zone == "") and (subZone ~= "") then
			location = subZone;
		elseif (zone ~= "") and (subZone == "") then
			location = zone;
		else
			location = DCoordsTempText;
		end
	else
		if (zone == "") and (subZone == "") then
			location = px .. " - " .. py;
		elseif (zone ~= "") and (subZone == "") then
			location = zone .. " - " .. playerCoordinats;
		elseif (zone == "") and (subZone ~= "") then
			location = subZone .. " - " .. playerCoordinats;
		elseif (zone ~= "") and (subZone ~= "") then
			if (zone == subZone) then
				location = zone .. " - " .. playerCoordinats;
			else
				location = zone .. " - " .. subZone .. " - " .. playerCoordinats;
			end
		else
			location = "      ";
		end
	end
	
	location = "  " .. location .. "  ";
	
	--DCVGlobal["DCMainBarText"]:SetText(" " .. t .. " " .. location);
	DCVGlobal["DCMainBarText"]:SetText(location);
	--DCVGlobal["DCMainBarText"]:SetJustifyH("LEFT");
	
	
	if (DCVGlobal["DCMainBar"]:IsVisible() == true) then	
		local frameW = DCVGlobal["DCMainBarText"]:GetStringWidth() + DCoordsVDB["MainBar"].paddingLeftRight;
		local frameH = DCVGlobal["DCMainBarText"]:GetStringHeight() + DCoordsVDB["MainBar"].paddingTopBottom;
		
		if (oldW ~= frameW) then
			oldW = frameW;
			DCVGlobal["DCMainBar"]:SetWidth(frameW);
			DCVGlobal["DCMainBar"]:SetHeight(frameH);
		end
	end
end
-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #

local oldW = 0;
local oldH = 0;




-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
function updateWorldMap()

	if ( WorldMapFrame:IsVisible() == false ) then
		return;
	end

	--DCVGlobal["DCWorldMapText"]:SetText(" " .. t .. " " .. location);
	
	-- World map calc
	local mapscale = WorldMapDetailFrame:GetEffectiveScale();
	local cursorX, cursorY = GetCursorPosition();
	cursorX = cursorX / mapscale;
	cursorY = cursorY / mapscale;
	local width = WorldMapDetailFrame:GetWidth();
	local height = WorldMapDetailFrame:GetHeight();
	local left = WorldMapDetailFrame:GetLeft();
	local top = WorldMapDetailFrame:GetTop();
	
	cursorX = (cursorX - left) / width * 100;
	cursorY = (top - cursorY) / height * 100;
	
	local cx, cy;
	if (DCoordsVDB["WorldMap"].decimalPrecision==3) then
		cx = format("%.3f",cursorX);
		cy = format("%.3f",cursorY);
	elseif (DCoordsVDB["WorldMap"].decimalPrecision==2) then
		cx = format("%.2f",cursorX);
		cy = format("%.2f",cursorY);
	elseif (DCoordsVDB["WorldMap"].decimalPrecision==1) then
		cx = format("%.1f",cursorX);
		cy = format("%.1f",cursorY);
	else
		cx = floor(cursorX);
		cy = floor(cursorY);
	end


	local playerCoordinats = getPlayerCoordinates(DCoordsVDB["WorldMap"].decimalPrecision);

	
	--DCVGlobal["DCWorldMapText"]:SetText("You: [" .. playerX .. " - " .. playerY .. "]     " .. DCoordsMapTextLabel);
	if (tonumber(px) < 0.01 and tonumber(py) < 0.01) then
		DCVGlobal["DCWorldMapText"]:SetText("Cursor " .. cx .. " : " .. cy);
	else 
		DCVGlobal["DCWorldMapText"]:SetText("You " .. playerCoordinats .. "     Cursor " .. cx .. " : " .. cy);
		--log(DCoordsMapTextLabel);
		--log(mouseIsOverMap);
		--log( GetMouseFocus():GetName() );
	end	
	
end
-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #