﻿--[[
    Author:Darcey@AllForTheCode.co.uk 
--]]

-- SavedVariableDefaults
if ( not DCoordsVDB ) then 
	DCoordsVDB = {};
	
	DCoordsVDB["visible"] = true;
	
	DCoordsVDB["FirstRun"] = true;
	
	DCoordsVDB["updateDelay"] = 5;
	DCoordsVDB["updateDelayInCombat"] = 40;
	DCoordsVDB["updateDelayInDungeonOrRaid"] = 100;

	DCoordsVDB["MainBar"] = {};
	DCoordsVDB["MainBar"].visible = true;
	DCoordsVDB["MainBar"].decimalPrecision = 2;
	DCoordsVDB["MainBar"].alignmentIndex = 7;

	DCoordsVDB["MainBar"].showZone = true;
	DCoordsVDB["MainBar"].showSubZone = true;
	DCoordsVDB["MainBar"].x = 0;
	DCoordsVDB["MainBar"].y = 0;

	DCoordsVDB["MainBar"].bgVisible = true;
	DCoordsVDB["MainBar"].bgSelectedIndex = 1;
	DCoordsVDB["MainBar"].bgR = 0;
	DCoordsVDB["MainBar"].bgG = 0;
	DCoordsVDB["MainBar"].bgB = 0;
	DCoordsVDB["MainBar"].bgA = 0.5;
	DCoordsVDB["MainBar"].paddingLeftRight = 0;
	DCoordsVDB["MainBar"].paddingTopBottom = 7.5;

	DCoordsVDB["MainBar"].fontSelectedIndex = 1;
	DCoordsVDB["MainBar"].fontAlignmentIndex = 4; -- setPoint
	DCoordsVDB["MainBar"].fontOffsetX = -0.1; -- setPoint
	DCoordsVDB["MainBar"].fontOffsetY = 0.7; -- setPoint
	DCoordsVDB["MainBar"].fontSelectedJustificationIndex = 1; -- text align
	DCoordsVDB["MainBar"].fontSize = 16;
	DCoordsVDB["MainBar"].fontR = 1;
	DCoordsVDB["MainBar"].fontG = 1;
	DCoordsVDB["MainBar"].fontB = 1;
	DCoordsVDB["MainBar"].fontA = 1;

	DCoordsVDB["WorldMap"] = {};
	DCoordsVDB["WorldMap"].visible = true;
	DCoordsVDB["WorldMap"].decimalPrecision = 2;
	DCoordsVDB["WorldMap"].fontAlignmentIndex = 2; -- setPoint
	DCoordsVDB["WorldMap"].fontOffsetY = 23; -- setPoint
	DCoordsVDB["WorldMap"].fontSelectedIndex = 1;
	DCoordsVDB["WorldMap"].fontSize = 18;
	DCoordsVDB["WorldMap"].fontR = 1;
	DCoordsVDB["WorldMap"].fontG = 1;
	DCoordsVDB["WorldMap"].fontB = 1;
	DCoordsVDB["WorldMap"].fontA = 1;
	
	DCoordsVDB["Minimap"] = {};
	DCoordsVDB["Minimap"].hideLocation = false;
	DCoordsVDB["Minimap"].fontSelectedIndex = 1;
	DCoordsVDB["Minimap"].fontSize = 16;
	DCoordsVDB["Minimap"].fontR = 1;
	DCoordsVDB["Minimap"].fontG = 1;
	DCoordsVDB["Minimap"].fontB = 1;
	DCoordsVDB["Minimap"].fontA = 1;

	DCoordsVDB["Objectives"] = {};
	DCoordsVDB["Objectives"].enabled = false;
	DCoordsVDB["Objectives"].alignmentIndex = 1;
	DCoordsVDB["Objectives"].alpha = 0.7;
	DCoordsVDB["Objectives"].scale = 0.8;
	DCoordsVDB["Objectives"].height = 300;
	DCoordsVDB["Objectives"].x = 0;
	DCoordsVDB["Objectives"].y = 0;
end


-- Libs
DCoordsLSM = LibStub("LibSharedMedia-3.0")


-- Globals
DCoordsVersion = "4.3.9";
DCoordsDebug = false;
DCoordsTempText = "DCoords waiting for data"; --"DCoords v" .. DCoordsVersion;
DCoordsInCombat = false;

DCoordsUIP = _G["UIParent"];

DCVGlobal = {};

DCVGlobal["DCUIFontSize"] = 14;

DCVGlobal["DCMainBarFrameName"] = nil;
DCVGlobal["DCMainBar"] = nil;
DCVGlobal["DCMainBarText"] = nil;
DCVGlobal["DCWorldMapText"] = nil;

DCVGlobal["DCOptions"] = nil;

DCVGlobal["DCLoaded"] = false;
DCVGlobal["DCVarsLoaded"] = false;

DCVGlobal["DCReady"] = false;
DCVGlobal["IsInCombat"] = false;

DCVGlobal["fontPath"] = "Interface\\Addons\\DCoords\\Fonts\\";
DCVGlobal["fontFiles"]  = {
	"AccidentalPresidency.ttf",
	"Lora-Regular.ttf",
	"Montserrat-Regular.ttf",
	"OpenSans-CondBold.ttf",
	"OpenSans-CondLight.ttf",
	"OpenSans-CondLightItalic.ttf",
	"MORPHEUS.TTF",
	"NotoSans-Bold.ttf",
	"NotoSans-Italic.ttf",
	"NotoSans-Regular.ttf",
	"stonehen.ttf",
	"tiffanynormal.ttf",
	"ARAMIS.TTF",
	"BRAVADO.TTF",
	"DIGIWOI_.TTF"
}
DCVGlobal["noOfFonts"] = 15; -- LUA doesn't have .length()! WTF

--DCVGlobal["AlignmentOptions"] = {"TOPLEFT","TOP","TOPRIGHT","LEFT","CENTER","RIGHT","BOTTOMLEFT","BOTTOM","BOTTOMRIGHT"};
DCVGlobal["AlignmentOptions"] = {"TOPLEFT","TOP","TOPRIGHT","LEFT","CENTER","RIGHT","BOTTOMLEFT","BOTTOM","BOTTOMRIGHT"};
DCVGlobal["WorldMapAlignmentOptions"] = {"TOP","BOTTOM"};
DCVGlobal["JustificationOptions"] = {"LEFT","CENTER","RIGHT"};

-- Register fonts
for i=1,#DCVGlobal["fontFiles"] do
	local fPath = DCVGlobal["fontPath"]..DCVGlobal["fontFiles"][i];
	--print(fPath);
	DCoordsLSM:Register ("font", "Font " .. tostring(i), fPath)
end

DCoordsUpdateFrame = nil;




function initVars()
	log("initVars()");
	
	DCoordsVDB = nil;
	DCoordsVDB = {};
	
	DCoordsVDB["visible"] = true;
	
	DCoordsVDB["updateDelay"] = 5;
	DCoordsVDB["updateDelayInCombat"] = 40;
	DCoordsVDB["updateDelayInDungeonOrRaid"] = 100;
	
	DCoordsVDB["FirstRun"] = true;

	DCoordsVDB["MainBar"] = {};
	DCoordsVDB["MainBar"].visible = true;
	DCoordsVDB["MainBar"].decimalPrecision = 2;
	DCoordsVDB["MainBar"].alignmentIndex = 7;

	DCoordsVDB["MainBar"].showZone = true;
	DCoordsVDB["MainBar"].showSubZone = true;
	DCoordsVDB["MainBar"].x = 0;
	DCoordsVDB["MainBar"].y = 0;

	DCoordsVDB["MainBar"].bgVisible = true;
	DCoordsVDB["MainBar"].bgSelectedIndex = 1;
	DCoordsVDB["MainBar"].bgR = 0;
	DCoordsVDB["MainBar"].bgG = 0;
	DCoordsVDB["MainBar"].bgB = 0;
	DCoordsVDB["MainBar"].bgA = 0.5;
	DCoordsVDB["MainBar"].paddingLeftRight = 0;
	DCoordsVDB["MainBar"].paddingTopBottom = 7.5;

	DCoordsVDB["MainBar"].fontSelectedIndex = 1;
	DCoordsVDB["MainBar"].fontAlignmentIndex = 4; -- setPoint
	DCoordsVDB["MainBar"].fontOffsetX = -0.1; -- setPoint
	DCoordsVDB["MainBar"].fontOffsetY = 0.7; -- setPoint
	DCoordsVDB["MainBar"].fontSelectedJustificationIndex = 1; -- text align
	DCoordsVDB["MainBar"].fontSize = 16;
	DCoordsVDB["MainBar"].fontR = 1;
	DCoordsVDB["MainBar"].fontG = 1;
	DCoordsVDB["MainBar"].fontB = 1;
	DCoordsVDB["MainBar"].fontA = 1;

	DCoordsVDB["WorldMap"] = {};
	DCoordsVDB["WorldMap"].visible = true;
	DCoordsVDB["WorldMap"].decimalPrecision = 2;
	DCoordsVDB["WorldMap"].fontAlignmentIndex = 2; -- setPoint
	DCoordsVDB["WorldMap"].fontOffsetY = 23; -- setPoint
	DCoordsVDB["WorldMap"].fontSelectedIndex = 1;
	DCoordsVDB["WorldMap"].fontSize = 18;
	DCoordsVDB["WorldMap"].fontR = 1;
	DCoordsVDB["WorldMap"].fontG = 1;
	DCoordsVDB["WorldMap"].fontB = 1;
	DCoordsVDB["WorldMap"].fontA = 1;
	
	DCoordsVDB["Minimap"] = {};
	DCoordsVDB["Minimap"].hideLocation = false;
	DCoordsVDB["Minimap"].fontSelectedIndex = 1;
	DCoordsVDB["Minimap"].fontSize = 16;
	DCoordsVDB["Minimap"].fontR = 1;
	DCoordsVDB["Minimap"].fontG = 1;
	DCoordsVDB["Minimap"].fontB = 1;
	DCoordsVDB["Minimap"].fontA = 1;
	DCoordsVDB["Minimap"].decimalPrecision = 2;

	DCoordsVDB["Objectives"] = {};
	DCoordsVDB["Objectives"].enabled = false;
	DCoordsVDB["Objectives"].alignmentIndex = 1;
	DCoordsVDB["Objectives"].alpha = 0.7;
	DCoordsVDB["Objectives"].scale = 0.8;
	DCoordsVDB["Objectives"].height = 300;
	DCoordsVDB["Objectives"].x = 0;
	DCoordsVDB["Objectives"].y = 0;
end