--[[
	Author: Darcey@AllForTheCode.co.uk
--]]


-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
function initObjectiveTracker()
    log("initObjectiveTracker()");
    
    if ( DCoordsVDB["Objectives"].enabled ) then
        enableDragOfObjectivesTracker();
        sliderObjectivesAlphaChangeHandler( DCoordsVDB["Objectives"].alpha );
        sliderObjectivesScaleChangeHandler(  DCoordsVDB["Objectives"].scale );
        sliderObjectivesHeightChangeHandler( DCoordsVDB["Objectives"].height );
    else
        DCoordsVDB["Objectives"].x = 0;
	    DCoordsVDB["Objectives"].y = 0;
    end

end
-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #







-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
function cbDragObjectivesChangeHandler(value)
    --log("cbDragObjectivesChangeHandler(value:"..tostring(value)..")");
    DCoordsVDB["Objectives"].enabled = value;
    
    if ( DCoordsVDB["Objectives"].enabled ) then
        initObjectiveTracker();
    else
        ReloadUI();
    end
end
-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #



-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
function sliderObjectivesAlphaChangeHandler(value)
    -- Prevent run if disabled
    if ( DCoordsVDB["Objectives"].enabled == false ) then
        return;
    end
    
    DCoordsVDB["Objectives"].alpha = value;
    ObjectiveTrackerFrame:SetAlpha( DCoordsVDB["Objectives"].alpha );
end
-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #



-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
function sliderObjectivesHeightChangeHandler(value)
    -- Prevent run if disabled
    if ( DCoordsVDB["Objectives"].enabled == false ) then
        return;
    end
    
    DCoordsVDB["Objectives"].height = value;
    ObjectiveTrackerFrame:SetHeight( DCoordsVDB["Objectives"].height );
end
-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #





-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
function sliderObjectivesScaleChangeHandler(value)
    -- Prevent run if disabled
    if ( DCoordsVDB["Objectives"].enabled == false ) then
        return;
    end
    
    DCoordsVDB["Objectives"].scale = value;
    ObjectiveTrackerFrame:SetScale( DCoordsVDB["Objectives"].scale );
end
-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #























-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
function enableDragOfObjectivesTracker()
    --log("enableDragOfObjectivesTracker()");
        

	if (ObjectiveTrackerFrame) then
		ObjectiveTrackerFrame:EnableMouse(true);
		ObjectiveTrackerFrame:SetResizable(true);
		ObjectiveTrackerFrame:SetMovable(true);

		if (not DCoordsVDB["Objectives"].x) then
			DCoordsVDB["Objectives"].x = ObjectiveTrackerFrame:GetLeft();
			DCoordsVDB["Objectives"].y = ObjectiveTrackerFrame:GetTop();
                  
            DCoordsVDB["Objectives"].x = 50;
			DCoordsVDB["Objectives"].y = 50;
		end
            
		ObjectiveTrackerFrame:ClearAllPoints()
		ObjectiveTrackerFrame.ClearAllPoints = function() end
		ObjectiveTrackerFrame:SetPoint("BOTTOMLEFT",DCoordsVDB["Objectives"].x,DCoordsVDB["Objectives"].y);
		ObjectiveTrackerFrame.SetPoint = function() end

		ObjectiveTrackerFrame:RegisterForDrag("LeftButton");
		ObjectiveTrackerFrame:SetScript("OnDragStart", function(self)
            if (IsShiftKeyDown()) then 
                toChat("DCoords: Objective tracker drag started!");
                self:StartMoving();
            end 
		end);

		ObjectiveTrackerFrame:SetScript("OnDragStop", function(self)
			if (not DCoordsVDB["Objectives"]) then
				DCoordsVDB["Objectives"].x = 0;
				DCoordsVDB["Objectives"].y = 0;
			else	
				DCoordsVDB["Objectives"].x = ObjectiveTrackerFrame:GetLeft();
				DCoordsVDB["Objectives"].y = ObjectiveTrackerFrame:GetTop()-ObjectiveTrackerFrame:GetHeight();
			end
			--log(DCoordsVDB["Objectives"].x  .. "," .. DCoordsVDB["Objectives"].y );
			self:StopMovingOrSizing()
		end);
		
	end
    
    --DCoordsVDB["Objectives"].x = 0;
    --log(DCoordsVDB["Objectives"].x  .. "," .. DCoordsVDB["Objectives"].y );

end
-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #


