--[[
	Author: Darcey@AllForTheCode.co.uk
--]]

local frame;

-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
function setupPageMainbar()
	DCVGlobal["DCOptions"].Mainbar = CreateFrame( "Frame", "DCoordsOptionsMainPage", UIParent );
	frame = DCVGlobal["DCOptions"].Mainbar;
	frame.name = "Coordinates bar";
	frame.parent = DCVGlobal["DCOptions"].Main.name;
	InterfaceOptions_AddCategory(frame);
	
	-- Add background to options to enhance readability
	frame:SetBackdrop({
		bgFile = "Interface/DialogFrame/UI-DialogBox-Background",
		edgeFile = "Interface/Tooltips/UI-Tooltip-Border",
		tile = true, tileSize = 10, edgeSize = 10,
		insets = { left = 3, right = 3, top = 3, bottom = 3 }
	})
	
	-- Titles
	AddDCoordsOptionsTitles(frame,"Coordinates bar");
	
	
	setupPageMainbarLeft();
	setupPageMainbarRight();
end
-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #





-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
function setupPageMainbarLeft()
	-- Vars
	local px = 10;
	local py = -60;
	local inc = 25;
	local dropDownWidth = 250;
	local sliderWidth = 250;
	local msg = "";
	
	--createCheckbox(name,frameContainer,label,checked,x,y,clickHandler)
	--createDropDown(name,frameContainer,width,labels,default,x,y,clickHandlerFunction)
	--createButton(name,frameContainer,label,width,x,y,clickHandler)
	--createSlider(name,frameContainer,min,max,step,default,width,decimalPrecision,x,y,changeHandler)
	
	
	--DCoordsVDB["MainBar"].visible
	local function cbVisibleClickHandler(ticked)
		DCoordsVDB["MainBar"].visible = ticked;
		mainBarSetVisibility();
	end
	createCheckbox("MainBarVisible",frame,"Coordinates bar visible",DCoordsVDB["MainBar"].visible,px,py,cbVisibleClickHandler);
	py = py - inc;
	
	
	
	--DCoordsVDB["MainBar"].showZone
	local function cbShowZoneClickHandler(ticked)
		DCoordsVDB["MainBar"].showZone = ticked;
		mainBarSetVisibility();
	end
	createCheckbox("cbShowZone",frame,"Show zone",DCoordsVDB["MainBar"].showZone,px,py,cbShowZoneClickHandler);
	py = py - inc;
	
	
	--DCoordsVDB["MainBar"].showSubZone
	local function cbShowSubZoneClickHandler(ticked)
		DCoordsVDB["MainBar"].showSubZone = ticked;
		mainBarSetVisibility();
	end
	createCheckbox("cbShowSubZone",frame,"Show sub zone",DCoordsVDB["MainBar"].showSubZone,px,py,cbShowSubZoneClickHandler);
	py = py - inc;
	
	
	
	
	
	
	
	--function createSliderDropReplacement(params)
	local sliderDropReplacementConfig = {};
	sliderDropReplacementConfig.name = "alignmentIndex";
	sliderDropReplacementConfig.frameContainer = frame;
	sliderDropReplacementConfig.width = sliderWidth;
	sliderDropReplacementConfig.labels = {
		"Addon is aligned to the TOP LEFT",
		"Addon is aligned to the TOP",
		"Addon is aligned to the TOP RIGHT",
		"Addon is aligned to the LEFT",
		"Addon is aligned to the CENTER",
		"Addon is aligned to the RIGHT",
		"Addon is aligned to the BOTTOM LEFT",
		"Addon is aligned to the BOTTOM",
		"Addon is aligned to the BOTTOM RIGHT"
	};
	sliderDropReplacementConfig.selected = DCoordsVDB["MainBar"].alignmentIndex;
	sliderDropReplacementConfig.x = px;
	sliderDropReplacementConfig.y = py;
	sliderDropReplacementConfig.changeHandler = function(v)
		DCoordsVDB["MainBar"].alignmentIndex = v;
		DCoordsVDB["MainBar"].x = 0;
    	DCoordsVDB["MainBar"].y = 0;
		mainBarSetFrameAlignment();
	end;
	createSliderDropReplacement(sliderDropReplacementConfig);
	py = py - 30;
	
	--[[
	--DCoordsVDB["MainBar"].alignmentIndex
	local function alignmentIndexChangeHandler(selectedIndex)
		DCoordsVDB["MainBar"].alignmentIndex = selectedIndex;
		DCoordsVDB["MainBar"].x = 0;
    	DCoordsVDB["MainBar"].y = 0;
		mainBarSetFrameAlignment();
	end
	local addonAlignmentLabels = {
		"Align addon to the TOP LEFT",
		"Align addon to the TOP",
		"Align addon to the TOP RIGHT",
		"Align addon to the LEFT",
		"Align addon to the CENTER",
		"Align addon to the RIGHT",
		"Align addon to the BOTTOM LEFT",
		"Align addon to the BOTTOM",
		"Align addon to the BOTTOM RIGHT"
	};
	createDropDown("alignmentIndex",frame,dropDownWidth,addonAlignmentLabels,DCoordsVDB["MainBar"].alignmentIndex,px,py,alignmentIndexChangeHandler)
	py = py - 19;
	--]]
	
	
	
	
	--createLabel((name,frameContainer,text,size,r,g,b,a,justify,x,y)
	msg = "";
	msg = msg .. "Addon alignment changes direction of growth." .. "\n\n";
	createLabel("DCAlignInfo1",frame,msg,14,1,0.5,0.5,1,"LEFT",27,py);
	py = py - 28;

	
	
	
	
	
	
	
	
	--function createSliderDropReplacement(params)
	local sliderFontSelection = {};
	sliderFontSelection.name = "fontSelectedIndex";
	sliderFontSelection.frameContainer = frame;
	sliderFontSelection.width = sliderWidth;
	sliderFontSelection.labels = {};
	for i = 1, 15, 1 do
		sliderFontSelection.labels[i] = "Coordinates bar use Font no' " .. tostring(i);
	end
	sliderFontSelection.selected = DCoordsVDB["MainBar"].fontSelectedIndex;
	sliderFontSelection.x = px;
	sliderFontSelection.y = py;
	sliderFontSelection.changeHandler = function(v)
		DCoordsVDB["MainBar"].fontSelectedIndex = v;
		mainBarSetFont();
	end;
	createSliderDropReplacement(sliderFontSelection);
	py = py - 40;
	
	
	--[[
	--DCoordsVDB["MainBar"].fontSelectedIndex
	local function fontSelectedIndexChangeHandler(selectedIndex)
		DCoordsVDB["MainBar"].fontSelectedIndex = selectedIndex;
		mainBarSetFont();
	end
	local fontLabels = {}
	for i = 1, 15, 1 do
		fontLabels[i] = "Coordinates bar use Font no' " .. tostring(i);
	end
	createDropDown("fontSelectedIndex",frame,dropDownWidth,fontLabels,DCoordsVDB["MainBar"].fontSelectedIndex,px,py,fontSelectedIndexChangeHandler)
	py = py - 50;
	--]]
	
	
	
	--DCoordsVDB["MainBar"].fontSize
	--function createSlider(name,frameContainer,min,max,step,label,default,width,decimalPrecision,x,y,changeHandler)
	local function fontSizeChangeHandler(v)
		if (v == nil) then
			v = 5;
		end
		
		if (v < 0.1) then
			v = 0.1;
		end
		
		DCoordsVDB["MainBar"].fontSize = v;
		mainBarSetFont();
	end
	createSlider("fontSize",frame,5,30,0.1,"Font size",DCoordsVDB["MainBar"].fontSize,sliderWidth,1,px,py,fontSizeChangeHandler,true)
	py = py - 50;
	
	
	
	--DCoordsVDB["MainBar"].decimalPrecision
	--function createSlider(name,frameContainer,min,max,step,label,default,width,decimalPrecision,x,y,changeHandler)
	local function mainBarDecimalPrecisionChangeHandler(v)
		DCoordsVDB["MainBar"].decimalPrecision = v;
	end
	createSlider("sMainBarDecimalPrecision",frame,0,3,1,"Coordinates bar decimal precision",DCoordsVDB["MainBar"].decimalPrecision,sliderWidth,0,px,py,mainBarDecimalPrecisionChangeHandler)
	py = py - 60;
	
	
	
	
	
	
	
	

	
	
	
	
	
	
	
	--createLabel((name,frameContainer,text,size,r,g,b,a,justify,x,y)
	msg = "";
	msg = msg .. "Main bar font color (RGBA)." .. "\n\n";
	createLabel("infoFontRGB",frame,msg,14,1,0.5,0.5,1,"LEFT",px,py);
	py = py - 18;
	
	
	local sliderTextColorW = 80;
	
	--DCoordsVDB["MainBar"].fontR
	--function createSlider(name,frameContainer,min,max,step,label,default,width,decimalPrecision,x,y,changeHandler)
	local function fontRChangeHandler(v)
		DCoordsVDB["MainBar"].fontR = v;
		mainBarSetFont();
	end
	createSlider("fontR",frame,0,1,0.1,"Red (RGB)",DCoordsVDB["MainBar"].fontR,sliderTextColorW-10,1,px,py,fontRChangeHandler)
	
	
	--DCoordsVDB["MainBar"].fontG
	--function createSlider(name,frameContainer,min,max,step,label,default,width,decimalPrecision,x,y,changeHandler)
	local function fontGChangeHandler(v)
		DCoordsVDB["MainBar"].fontG = v;
		mainBarSetFont();
	end
	createSlider("fontG",frame,0,1,0.1,"Green (RGB)",DCoordsVDB["MainBar"].fontG,sliderTextColorW-10,1,px+(sliderTextColorW),py,fontGChangeHandler)
	
	
	--DCoordsVDB["MainBar"].fontB
	--function createSlider(name,frameContainer,min,max,step,label,default,width,decimalPrecision,x,y,changeHandler)
	local function fontBChangeHandler(v)
		DCoordsVDB["MainBar"].fontB = v;
		mainBarSetFont();
	end
	createSlider("fontB",frame,0,1,0.1,"Blue (RGB)",DCoordsVDB["MainBar"].fontB,sliderTextColorW-10,1,px+(sliderTextColorW*2),py,fontBChangeHandler)
	py = py - 40;
	
	
	--DCoordsVDB["MainBar"].fontA
	--function createSlider(name,frameContainer,min,max,step,label,default,width,decimalPrecision,x,y,changeHandler)
	local function fontAChangeHandler(v)
		DCoordsVDB["MainBar"].fontA = v;
		mainBarSetFont();
	end
	createSlider("fontA",frame,0,1,0.1,"Alpha",DCoordsVDB["MainBar"].fontA,sliderTextColorW-10,1,px,py,fontAChangeHandler)
	py = py - 40;
	
end
-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #






-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
function setupPageMainbarRight()
	-- Vars
	local px = 350;
	local py = -60;
	local inc = 25;
	local dropDownWidth = 250;
	local sliderWidth = 250;
	
	--createCheckbox(name,frameContainer,label,checked,x,y,clickHandler)
	--createDropDown(name,frameContainer,width,labels,default,x,y,clickHandlerFunction)
	--createButton(name,frameContainer,label,width,x,y,clickHandler)
	--createSlider(name,frameContainer,min,max,step,default,width,decimalPrecision,x,y,changeHandler)
	
	--DCoordsVDB["MainBar"].bgVisible
	local function mainBarShowBackgroundClickHandler(ticked)
		log("mainBarShowBackgroundClickHandler(ticked:"..tostring(ticked) .. ")");
		DCoordsVDB["MainBar"].bgVisible = ticked;
		mainBarSetBackground();
		
		--DCoordsVDB["MainBar"].x = 0;
		--DCoordsVDB["MainBar"].y = 0;
		--log( "bg change pos left:"..DCVGlobal["DCMainBar"]:GetLeft());
		--log( "bg change pos top:"..DCVGlobal["DCMainBar"]:GetTop());
		--mainBarSetPosition();
		
		--[[
		if (ticked == true) then
			toChat("CORRECTING Y!");
			--DCoordsVDB["MainBar"].y = DCoordsVDB["MainBar"].y - 30;
			mainBarSetFrameAlignment();
			DCoordsDragEnd();
		end
		--]]
	end
	createCheckbox("MainBarShowBackground",frame,"Show background",DCoordsVDB["MainBar"].bgVisible,px,py,mainBarShowBackgroundClickHandler);
	py = py - inc;
	
	
	
	
	
	
	
	--function createSliderDropReplacement(params)
	local sliderBackgroundType = {};
	sliderBackgroundType.name = "bgSelectedIndex";
	sliderBackgroundType.frameContainer = frame;
	sliderBackgroundType.width = sliderWidth;
	sliderBackgroundType.labels = {
		"Use Classic background",
		"Use Box background"
	};
	sliderBackgroundType.selected = DCoordsVDB["MainBar"].bgSelectedIndex;
	sliderBackgroundType.x = px;
	sliderBackgroundType.y = py;
	sliderBackgroundType.changeHandler = function(v)
		DCoordsVDB["MainBar"].bgSelectedIndex = v;
		mainBarSetBackground();
	end;
	createSliderDropReplacement(sliderBackgroundType);
	py = py - 60;
	
	
	
	--[[
	--DCoordsVDB["MainBar"].bgSelectedIndex
	local function mainBarBackgroundDropDownChangeHandler(selectedIndex)
		log("mainBarBackgroundDropDownChangeHandler(selectedIndex)");
		DCoordsVDB["MainBar"].bgSelectedIndex = selectedIndex;
		mainBarSetBackground();
	end
	local labels = {
		"Classic",
		"Box"
	};
	createDropDown("bgSelectedIndex",frame,dropDownWidth,labels,DCoordsVDB["MainBar"].bgSelectedIndex,px,py,mainBarBackgroundDropDownChangeHandler)
	py = py - 30;
	--]]
	
	
	
	
	
	
	
	
	
	--createLabel((name,frameContainer,text,size,r,g,b,a,justify,x,y)
	msg = "";
	msg = msg .. "Text padding." .. "\n\n";
	createLabel("txtPaddingInfor",frame,msg,14,1,0.5,0.5,1,"LEFT",px,py);
	py = py - 18;
	
	--DCoordsVDB["MainBar"].paddingLeftRight
	--function createSlider(name,frameContainer,min,max,step,label,default,width,decimalPrecision,x,y,changeHandler)
	local function paddingLeftRightSlideChangeHandler(v)
		DCoordsVDB["MainBar"].paddingLeftRight = v;
	end
	createSlider("paddingLeftRight",frame,0,100,0.1,"Left/Right",DCoordsVDB["MainBar"].paddingLeftRight,(sliderWidth/2)-10,1,px,py,paddingLeftRightSlideChangeHandler,true)
	
	
	
	--DCoordsVDB["MainBar"].paddingTopBottom
	--function createSlider(name,frameContainer,min,max,step,label,default,width,decimalPrecision,x,y,changeHandler)
	local function paddingTopBtmSlideChangeHandler(v)
		DCoordsVDB["MainBar"].paddingTopBottom = v;
	end
	createSlider("paddingTopBtm",frame,0,100,0.1,"Top/Bottom",DCoordsVDB["MainBar"].paddingTopBottom,(sliderWidth/2)-10,1,px+(sliderWidth/2),py,paddingTopBtmSlideChangeHandler,true)
	py = py - 60;
	
	
	

	
	
	
	--DCoordsVDB["MainBar"].fontOffsetX
	--function createSlider(name,frameContainer,min,max,step,label,default,width,decimalPrecision,x,y,changeHandler)
	local function fontOffsetXChangeHandler(v)
		DCoordsVDB["MainBar"].fontOffsetX = v;
		mainBarSetFont();
	end
	createSlider("fontOffsetX",frame,-10,10,0.1,"Offset X",DCoordsVDB["MainBar"].fontOffsetX,(sliderWidth/2)-10,1,px,py,fontOffsetXChangeHandler,true)
	
	
	
	--DCoordsVDB["MainBar"].fontOffsetY
	--function createSlider(name,frameContainer,min,max,step,label,default,width,decimalPrecision,x,y,changeHandler)
	local function fontOffsetYChangeHandler(v)
		DCoordsVDB["MainBar"].fontOffsetY = v;
		mainBarSetFont();
	end
	createSlider("fontOffsetY",frame,-10,10,0.1,"Offset Y",DCoordsVDB["MainBar"].fontOffsetY,(sliderWidth/2)-10,1,px+(sliderWidth/2),py,fontOffsetYChangeHandler,true)
	py = py - 70;
	
	
	
	
	
	
		
	
	
	--createLabel((name,frameContainer,text,size,r,g,b,a,justify,x,y)
	msg = "";
	msg = msg .. "Solid background color." .. "\n\n";
	createLabel("solidBgColorInfo",frame,msg,14,1,0.5,0.5,1,"LEFT",px,py);
	py = py - 18;
	
	
	local bgSliderW = 80;
	
	--DCoordsVDB["MainBar"].bgR
	--function createSlider(name,frameContainer,min,max,step,label,default,width,decimalPrecision,x,y,changeHandler)
	local function bgRChangeHandler(v)
		DCoordsVDB["MainBar"].bgR = v;
		updateBoxBgColor();
	end
	createSlider("bgRChangeHandler",frame,0,1,0.1,"Red (RGB)",DCoordsVDB["MainBar"].bgR,bgSliderW-10,1,px,py,bgRChangeHandler)
	
	
	--DCoordsVDB["MainBar"].bgG
	--function createSlider(name,frameContainer,min,max,step,label,default,width,decimalPrecision,x,y,changeHandler)
	local function bgGChangeHandler(v)
		DCoordsVDB["MainBar"].bgG = v;
		updateBoxBgColor();
	end
	createSlider("bgGChangeHandler",frame,0,1,0.1,"Green (RGB)",DCoordsVDB["MainBar"].bgG,bgSliderW-10,1,px+bgSliderW,py,bgGChangeHandler)
	
	
	--DCoordsVDB["MainBar"].bgB
	--function createSlider(name,frameContainer,min,max,step,label,default,width,decimalPrecision,x,y,changeHandler)
	local function bgBChangeHandler(v)
		DCoordsVDB["MainBar"].bgB = v;
		updateBoxBgColor();
	end
	createSlider("bgBChangeHandler",frame,0,1,0.1,"Blue (RGB)",DCoordsVDB["MainBar"].bgB,bgSliderW-10,1,px+(bgSliderW*2),py,bgBChangeHandler)
	py = py - 40;
	
	
	--DCoordsVDB["MainBar"].bgA
	--function createSlider(name,frameContainer,min,max,step,label,default,width,decimalPrecision,x,y,changeHandler)
	local function bgAChangeHandler(v)
		DCoordsVDB["MainBar"].bgA = v;
		updateBoxBgColor();
	end
	createSlider("bgAChangeHandler",frame,0,1,0.1,"Alpha",DCoordsVDB["MainBar"].bgA,bgSliderW-10,1,px,py,bgAChangeHandler)
	py = py - 60;
	
	
	
	
	
	
	
	
	
		
	
	
	--createLabel((name,frameContainer,text,size,r,g,b,a,justify,x,y)
	msg = "";
	msg = msg .. "Position X & Y (RECOMMEND: Drag to position)." .. "\n\n";
	createLabel("infoOffset",frame,msg,14,1,0.5,0.5,1,"LEFT",px,py);
	py = py - 18;
	
	
	local mainBarPosRange = 3000;
	
	
	--DCoordsVDB["MainBar"].x
	--function createSlider(name,frameContainer,min,max,step,label,default,width,decimalPrecision,x,y,changeHandler)
	local function xChangeHandler(v)
		DCoordsVDB["MainBar"].x = v;
		mainBarSetFrameAlignment();
	end
	createSlider("xChangeHandler",frame,-mainBarPosRange,mainBarPosRange,1,"Coordinates bar X",DCoordsVDB["MainBar"].x,sliderWidth,0,px,py,xChangeHandler,true)
	py = py - 50;
	
	--DCoordsVDB["MainBar"].y
	--function createSlider(name,frameContainer,min,max,step,label,default,width,decimalPrecision,x,y,changeHandler)
	local function yChangeHandler(v)
		DCoordsVDB["MainBar"].y = v;
		mainBarSetFrameAlignment();
	end
	createSlider("yChangeHandler",frame,-mainBarPosRange,mainBarPosRange,1,"Coordinates bar Y",DCoordsVDB["MainBar"].y,sliderWidth,0,px,py,yChangeHandler,true)
	py = py - 50;
	
	
	
	
	
	
	
end
-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #