--[[
	Author: Darcey@AllForTheCode.co.uk
--]]


-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
function setupPageMinimap()
	DCVGlobal["DCOptions"].Minimap = CreateFrame("FRAME", "DCoordsOptionsMainBar");
	local frame = DCVGlobal["DCOptions"].Minimap; 
	frame.name = "Minimap";
	frame.parent = DCVGlobal["DCOptions"].Main.name;
	InterfaceOptions_AddCategory(frame);
	
	-- Add background to options to enhance readability
	frame:SetBackdrop({
		bgFile = "Interface/DialogFrame/UI-DialogBox-Background",
		edgeFile = "Interface/Tooltips/UI-Tooltip-Border",
		tile = true, tileSize = 10, edgeSize = 10,
		insets = { left = 3, right = 3, top = 3, bottom = 3 }
	})
	
	-- Titles
	AddDCoordsOptionsTitles(frame,"Minimap");
	
	
	-- Vars
	local px = 10;
	local py = -60;
	local inc = 25;
	local dropDownWidth = 200;
	local sliderWidth = 200;
	
	--createCheckbox(name,frameContainer,label,checked,x,y,clickHandler)
	--createDropDown(name,frameContainer,width,labels,default,x,y,clickHandlerFunction)
	--createButton(name,frameContainer,label,width,x,y,clickHandler)
	--createSlider(name,frameContainer,min,max,step,default,width,decimalPrecision,x,y,changeHandler)
	
	-- ensure variables are available
	
	if (not DCoordsVDB["Minimap"].decimalPrecision) then
		DCoordsVDB["Minimap"].fontSelectedIndex = 1;
		DCoordsVDB["Minimap"].fontSize = 16;
		DCoordsVDB["Minimap"].decimalPrecision = 2;
		DCoordsVDB["Minimap"].fontR = 1;
		DCoordsVDB["Minimap"].fontG = 1;
		DCoordsVDB["Minimap"].fontB = 1;
		DCoordsVDB["Minimap"].fontA = 1;
	end
	
	
	
	
	--DCoordsVDB["Minimap"].visible
	local function hideLocationClickHandler(ticked)
		DCoordsVDB["Minimap"].hideLocation = ticked;
		updateMinimap();
	end
	createCheckbox("MinimapHideLocation",frame,"Hide minimap location bar",DCoordsVDB["Minimap"].hideLocation,px,py,hideLocationClickHandler);
	py = py - 46;
	
	
	
	
	
	--function createSliderDropReplacement(params)
	local sliderMinimapFontSelection = {};
	sliderMinimapFontSelection.name = "MinimapFontSelectedIndex";
	sliderMinimapFontSelection.frameContainer = frame;
	sliderMinimapFontSelection.width = sliderWidth;
	sliderMinimapFontSelection.labels = {};
	for i = 1, 15, 1 do
		sliderMinimapFontSelection.labels[i] = "Minimap use Font no' " .. tostring(i);
	end
	sliderMinimapFontSelection.selected = DCoordsVDB["Minimap"].fontSelectedIndex;
	sliderMinimapFontSelection.x = px;
	sliderMinimapFontSelection.y = py;
	sliderMinimapFontSelection.changeHandler = function(v)
		DCoordsVDB["Minimap"].fontSelectedIndex = v;
		minimapSetFont();
	end;
	createSliderDropReplacement(sliderMinimapFontSelection);
	py = py - 40;	
	
	
	
	
	--function createSlider(name,frameContainer,min,max,step,label,default,width,decimalPrecision,x,y,changeHandler)
	local function miniMapFontSizeChangeHandler(v)
		if (v == nil) then
			v = 5;
		end
		
		if (v < 9) then
			v = 9;
		end
	
		DCoordsVDB["Minimap"].fontSize = v;
		minimapSetFont();
	end
	createSlider("MinimapFontSize",frame,9,30,0.1,"Minimap font size",DCoordsVDB["Minimap"].fontSize,sliderWidth,1,px,py,miniMapFontSizeChangeHandler)
	py = py - 60;
	
	
	
	
	--function createSlider(name,frameContainer,min,max,step,label,default,width,decimalPrecision,x,y,changeHandler)
	local function miniMapPrecisionChangeHandler(v)
		DCoordsVDB["Minimap"].decimalPrecision = v;
	end
	createSlider("sliderMiniMapPrecision",frame,0,3,1,"Minimap decimal precision",DCoordsVDB["Minimap"].decimalPrecision,sliderWidth,0,px,py,miniMapPrecisionChangeHandler)
	py = py - 60;
	
	
end
-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #





-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
function updateMinimap()

	if (DCoordsVDB["Minimap"].hideLocation)then
			MiniMapWorldMapButton:Hide()
			MinimapZoneTextButton:Hide();
			--MinimapBorder:Hide()
			MinimapBorderTop:Hide()
			--Minimap:SetMaskTexture("Interface\\BUTTONS\\WHITE8X8")
	else
			MiniMapWorldMapButton:Show()
			MinimapZoneTextButton:Show();
			--MinimapBorder:Show()
			MinimapBorderTop:Show()
			--Minimap:SetMaskTexture("Interface\\BUTTONS\\WHITE8X8")
	end

end
-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #